Index: ChangeLog
===================================================================
--- ChangeLog	(revision 9ab94a1fc7c4817a4d6ddf2b37a366c46abb2609)
+++ ChangeLog	(revision 224aebb3b8ceb936e333e4c9b71bfb95737f4c5e)
@@ -1,2 +1,9 @@
+2008-07-09	Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* aclocal/bsp-alias.m4, aclocal/check-bsps.m4,
+	make/custom/m5484FireEngine.cfg:
+	added pgh360 BSP variant
+	added m5484FireEngine BSP
+
 2008-06-01	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: README.configure
===================================================================
--- README.configure	(revision 9ab94a1fc7c4817a4d6ddf2b37a366c46abb2609)
+++ README.configure	(revision 224aebb3b8ceb936e333e4c9b71bfb95737f4c5e)
@@ -195,4 +195,5 @@
 		mvme167 ods68302 sim68000 mcf5206elite uC5282 
 		gen68302 csb360 simcpu32 mrm332 av5282 gen68340 mcf5235 idp
+		m5484FireEngine
 
 no_cpu          : no_bsp  (porting example)
Index: aclocal/bsp-alias.m4
===================================================================
--- aclocal/bsp-alias.m4	(revision 9ab94a1fc7c4817a4d6ddf2b37a366c46abb2609)
+++ aclocal/bsp-alias.m4	(revision 224aebb3b8ceb936e333e4c9b71bfb95737f4c5e)
@@ -11,4 +11,6 @@
     c3xsim)       $2=c4xsim           ;; # TI C3x Simulator in gdb
     gen68360_040) $2=gen68360         ;; # m68k - 68360 in companion mode
+    pgh360)       $2=gen68360         ;; # m68k - 68360 custom board
+    m5484FireEngine) $2=genmcf548x    ;; # m68k - mcf548x eva board
     mbx8*)        $2=mbx8xx           ;; # MBX821/MBX860 board
     mcp750)       $2=motorola_powerpc ;; # Motorola PPC board variant
Index: aclocal/check-bsps.m4
===================================================================
--- aclocal/check-bsps.m4	(revision 9ab94a1fc7c4817a4d6ddf2b37a366c46abb2609)
+++ aclocal/check-bsps.m4	(revision 224aebb3b8ceb936e333e4c9b71bfb95737f4c5e)
@@ -18,5 +18,6 @@
         # Now account for BSPs with build variants
           c4xsim)            bsps="c4xsim c3xsim";;
-          gen68360)          bsps="gen68360 gen68360_040";;
+          gen68360)          bsps="gen68360 gen68360_040 pgh360";;
+          genmcf548x)        bsps="m5484FireEngine";;
           p4000)             bsps="p4600 p4650";;
           mvme162)           bsps="mvme162 mvme162lx";;
Index: c/src/ChangeLog
===================================================================
--- c/src/ChangeLog	(revision 9ab94a1fc7c4817a4d6ddf2b37a366c46abb2609)
+++ c/src/ChangeLog	(revision 224aebb3b8ceb936e333e4c9b71bfb95737f4c5e)
@@ -1,2 +1,9 @@
+2008-07-09	Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* libchip/display/disp_fonts.h, libchip/display/disp_hcms29xx.c
+	* libchip/display/disp_hcms29xx.h, libchip/display/font_hcms29xx.c
+	* libchip/display/font_hcms29xx.h
+	Creation of SPI display driver
+
 2008-07-09	Sebastian Huber <sebastian.huber@embedded-brains.de>
 
Index: cpukit/ChangeLog
===================================================================
--- cpukit/ChangeLog	(revision 9ab94a1fc7c4817a4d6ddf2b37a366c46abb2609)
+++ cpukit/ChangeLog	(revision 224aebb3b8ceb936e333e4c9b71bfb95737f4c5e)
@@ -1,2 +1,16 @@
+2008-07-10     Peter Rasmussen <Peter.Rasmussen@embedded-brains.de>
+
+	* score/cpu/m68k/cpu_asm.S, cpukit/score/cpu/m68k/rtems/asm.h, 
+	cpukit/score/cpu/m68k/rtems/score/cpu.h, 
+	score/cpu/m68k/rtems/score/m68k.h:
+
+	added support to save coldfire FPU/EMAC context
+
+2008-07-10     Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* libi2c/libi2c.c, libi2c/libi2c.h:
+	make buffer passed to *write* functions a const pointer
+
+
 2008-07-10	Till Straumann <strauman@slac.stanford.edu>
 
Index: cpukit/Makefile.am
===================================================================
--- cpukit/Makefile.am	(revision 9ab94a1fc7c4817a4d6ddf2b37a366c46abb2609)
+++ cpukit/Makefile.am	(revision 224aebb3b8ceb936e333e4c9b71bfb95737f4c5e)
@@ -67,5 +67,6 @@
 include_rtems_HEADERS += include/rtems/bspIo.h include/rtems/userenv.h \
     include/rtems/fs.h include/rtems/pci.h include/rtems/stdint.h \
-    include/rtems/concat.h include/rtems/tar.h
+    include/rtems/concat.h include/rtems/tar.h \
+    include/rtems/status-checks.h
 
 include_rtems_HEADERS += include/rtems/endian.h
@@ -73,4 +74,6 @@
 ## should be conditional and only installed for PowerPC, x86, and ARM
 include_rtems_HEADERS += include/rtems/irq.h
+
+include_rtems_HEADERS += include/rtems/irq-extension.h
 
 ## libfs
Index: cpukit/include/rtems/status-checks.h
===================================================================
--- cpukit/include/rtems/status-checks.h	(revision 9ab94a1fc7c4817a4d6ddf2b37a366c46abb2609)
+++ cpukit/include/rtems/status-checks.h	(revision 224aebb3b8ceb936e333e4c9b71bfb95737f4c5e)
@@ -35,4 +35,8 @@
   #endif /* DEBUG_PRINT */
 #else /* DEBUG */
+  #ifdef DEBUG_PRINT
+    #warning DEBUG_PRINT was defined, but DEBUG was undefined
+    #undef DEBUG_PRINT
+  #endif /* DEBUG_PRINT */
   #define DEBUG_PRINT( fmt, ...)
 #endif /* DEBUG */
@@ -40,7 +44,9 @@
 #ifndef SYSLOG_PRINT
   #ifdef RTEMS_STATUS_CHECKS_USE_PRINTK
-    #define SYSLOG_PRINT( fmt, ...) printk( fmt, ##__VA_ARGS__)
+    #define SYSLOG_PRINT( fmt, ...) \
+      printk( fmt, ##__VA_ARGS__)
   #else /* RTEMS_STATUS_CHECKS_USE_PRINTK */
-    #define SYSLOG_PRINT( fmt, ...) printf( fmt, ##__VA_ARGS__)
+    #define SYSLOG_PRINT( fmt, ...) \
+      printf( fmt, ##__VA_ARGS__)
   #endif /* RTEMS_STATUS_CHECKS_USE_PRINTK */
 #endif /* SYSLOG_PRINT */
@@ -178,5 +184,5 @@
     rv = val; \
     SYSLOG_ERROR( "RV = %i: %s\n", rv, hint ); \
-    goto label;
+    goto label; \
   } while (0)
 
Index: make/ChangeLog
===================================================================
--- make/ChangeLog	(revision 9ab94a1fc7c4817a4d6ddf2b37a366c46abb2609)
+++ make/ChangeLog	(revision 224aebb3b8ceb936e333e4c9b71bfb95737f4c5e)
@@ -1,2 +1,7 @@
+2008-07-09	Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* custom/pgh360.cfg:
+	Creation from gen68360.cfg
+
 2008-06-29	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: make/custom/pgh360.cfg
===================================================================
--- make/custom/pgh360.cfg	(revision 224aebb3b8ceb936e333e4c9b71bfb95737f4c5e)
+++ make/custom/pgh360.cfg	(revision 224aebb3b8ceb936e333e4c9b71bfb95737f4c5e)
@@ -0,0 +1,21 @@
+# 
+#  Config file for a "generic 68360" BSP
+#
+#  $Id$
+#
+
+RTEMS_CPU=m68k
+RTEMS_CPU_MODEL=m68360
+RTEMS_BOARD_MODEL=PGH360
+
+include $(RTEMS_ROOT)/make/custom/default.cfg
+
+# This is the actual bsp directory used during the build process.
+RTEMS_BSP_FAMILY=gen68360
+
+# This contains the compiler options necessary to select the CPU model
+# and (hopefully) optimize for it.
+CPU_CFLAGS = -mcpu32 -D$(RTEMS_BOARD_MODEL)
+
+# optimize flag: typically -O2
+CFLAGS_OPTIMIZE_V = -O2 -g -fomit-frame-pointer