Index: ChangeLog
===================================================================
--- ChangeLog	(revision 7a55888efe76f3b0a1dec2804a1166e2ab885b7e)
+++ ChangeLog	(revision 227ae749dc5888a8210e8fd9ee6673e357bc988d)
@@ -1,2 +1,7 @@
+2001-01-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* aclocal/bsp-alias.m4, aclocal/check-bsps.m4: Add simsh7032 and
+	simsh7045.
+
 2001-01-03	Emmanuel Raguet <raguet@crf.canon.fr>
 
Index: aclocal/bsp-alias.m4
===================================================================
--- aclocal/bsp-alias.m4	(revision 7a55888efe76f3b0a1dec2804a1166e2ab885b7e)
+++ aclocal/bsp-alias.m4	(revision 227ae749dc5888a8210e8fd9ee6673e357bc988d)
@@ -25,4 +25,6 @@
     leon1)     	  $2=leon             ;; # leon without fpu
     leon2)     	  $2=leon             ;; # leon with fpu
+    simsh7032)    $2=shsim            ;; # SH7032 simulator
+    simsh7045)    $2=shsim            ;; # SH7045 simulator
     *)            $2=$1;;
   esac]
Index: aclocal/check-bsps.m4
===================================================================
--- aclocal/check-bsps.m4	(revision 7a55888efe76f3b0a1dec2804a1166e2ab885b7e)
+++ aclocal/check-bsps.m4	(revision 227ae749dc5888a8210e8fd9ee6673e357bc988d)
@@ -32,4 +32,5 @@
 	leon)              rtems_bsp="$rtems_bsp leon1 leon2";;
 	sim68000)          rtems_bsp="$rtems_bsp sim68000 simcpu32";;
+	shsim)             rtems_bsp="$rtems_bsp simsh7032 simsh7045";;
         *) $1="[$]$1 $file";;
       esac;
Index: make/ChangeLog
===================================================================
--- make/ChangeLog	(revision 7a55888efe76f3b0a1dec2804a1166e2ab885b7e)
+++ make/ChangeLog	(revision 227ae749dc5888a8210e8fd9ee6673e357bc988d)
@@ -1,2 +1,7 @@
+2001-01-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+2001-02-03	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+	* aclocal/bsp-alias.m4, aclocal/check-bsps.m4: Add simsh7032 and
+	simsh7045.
+	* ChangeLog: Remove bogus 2001-01-22 entry.
 
 2001-01-09	Joel Sherrill <joel@OARcorp.com>
Index: make/custom/shsim.cfg
===================================================================
--- make/custom/shsim.cfg	(revision 7a55888efe76f3b0a1dec2804a1166e2ab885b7e)
+++ make/custom/shsim.cfg	(revision 227ae749dc5888a8210e8fd9ee6673e357bc988d)
@@ -5,11 +5,17 @@
 #
 
+HZ=20000000
+
 include $(RTEMS_ROOT)/make/custom/default.cfg
 
 RTEMS_CPU=sh
-RTEMS_CPU_MODEL=sh1
+RTEMS_CPU_MODEL=sh7032
 
 # This is the actual bsp directory used during the build process.
 RTEMS_BSP_FAMILY=shsim
+
+# BSP specific preprocessor flags.
+# These should only be used in BSP dependent directories.
+BSP_CPPFLAGS=-DHZ=$(HZ)
 
 #  This contains the compiler options necessary to select the CPU model
@@ -32,14 +38,4 @@
 # will be able to override parts of the compilers specs and link using gcc.
 
-ifeq ($(RTEMS_USE_GCC272),yes)
-
-define make-exe
-	$(LD) -u _sbrk $(LDFLAGS) -N -T $(LINKCMDS) -o $(basename $@).exe \
-	     $(START_FILE) $(LINK_OBJS) --start-group $(LINK_LIBS) --end-group
-	$(NM) -g -n $(basename $@).exe > $(basename $@).num
-	$(SIZE) $(basename $@).exe
-endef
-
-else
 define make-exe
 	$(LINK.c) $(AM_CFLAGS) $(AM_LDFLAGS) \
@@ -49,5 +45,4 @@
 	$(SIZE) $@
 endef
-endif
 
 # Miscellaneous additions go here
Index: make/custom/simsh7032.cfg
===================================================================
--- make/custom/simsh7032.cfg	(revision 227ae749dc5888a8210e8fd9ee6673e357bc988d)
+++ make/custom/simsh7032.cfg	(revision 227ae749dc5888a8210e8fd9ee6673e357bc988d)
@@ -0,0 +1,30 @@
+#
+#  simsh7032.cfg
+#
+#  default configuration for gdb-simulation of Hitachi sh7032 processors
+#
+#  Author: Ralf Corsepius (corsepiu@faw.uni-ulm.de)
+#
+#  $Id$
+#
+
+include $(RTEMS_ROOT)/make/custom/shsim.cfg
+
+RTEMS_CPU=sh
+RTEMS_CPU_MODEL=sh7032
+
+#
+#  This contains the compiler options necessary to select the CPU model
+#  and (hopefully) optimize for it.
+#
+CPU_CFLAGS=-m1
+
+# debug flags: typically none, but we use -O1 as it produces better code
+# CFLAGS_DEBUG_V = -O1
+CFLAGS_DEBUG_V =
+
+# optimize flag: typically -0, could use -O4 or -fast
+# -O4 is ok for RTEMS
+CFLAGS_OPTIMIZE_V = -O4 
+
+# Miscellaneous additions go here
Index: make/custom/simsh7045.cfg
===================================================================
--- make/custom/simsh7045.cfg	(revision 227ae749dc5888a8210e8fd9ee6673e357bc988d)
+++ make/custom/simsh7045.cfg	(revision 227ae749dc5888a8210e8fd9ee6673e357bc988d)
@@ -0,0 +1,30 @@
+#
+#  simsh7045.cfg
+#
+#  default configuration for gdb-simulation of Hitachi sh7045 processors
+#
+#  Author: Ralf Corsepius (corsepiu@faw.uni-ulm.de)
+#
+#  $Id$
+#
+
+include $(RTEMS_ROOT)/make/custom/shsim.cfg
+
+RTEMS_CPU=sh
+RTEMS_CPU_MODEL=sh7045
+
+#
+#  This contains the compiler options necessary to select the CPU model
+#  and (hopefully) optimize for it.
+#
+CPU_CFLAGS=-m2
+
+# debug flags: typically none, but we use -O1 as it produces better code
+# CFLAGS_DEBUG_V = -O1
+CFLAGS_DEBUG_V =
+
+# optimize flag: typically -0, could use -O4 or -fast
+# -O4 is ok for RTEMS
+CFLAGS_OPTIMIZE_V = -O4 
+
+# Miscellaneous additions go here