Index: contrib/crossrpms/rtems4.10/arm/rtems-4.10-arm-rtems4.10-gcc.spec
===================================================================
--- contrib/crossrpms/rtems4.10/arm/rtems-4.10-arm-rtems4.10-gcc.spec	(revision 68946ac7481b9e0d5ce43986e29fc18c49181b71)
+++ contrib/crossrpms/rtems4.10/arm/rtems-4.10-arm-rtems4.10-gcc.spec	(revision 241a259dec4d836b991515ef2a67bd7e0bd2cc24)
@@ -61,5 +61,5 @@
 Group:	      	Development/Tools
 Version:        %{gcc_rpmvers}
-Release:      	11%{?dist}
+Release:      	12%{?dist}
 License:      	GPL
 URL:		http://gcc.gnu.org
@@ -101,5 +101,5 @@
 Requires:	rtems-4.10-gcc-common
 Requires:	rtems-4.10-arm-rtems4.10-binutils
-Requires:	rtems-4.10-arm-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+Requires:	rtems-4.10-arm-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 
 
@@ -435,5 +435,5 @@
 # Version:        %{gcc_rpmvers}
 # Requires:       rtems-4.10-arm-rtems4.10-binutils
-# Requires:       rtems-4.10-arm-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+# Requires:       rtems-4.10-arm-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 # License:	GPL
 
@@ -587,5 +587,5 @@
 License:	Distributable
 Version:	%{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 
 Requires:	rtems-4.10-newlib-common
@@ -607,5 +607,5 @@
 Group:          Development/Tools
 Version:        %{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 License:	Distributable
 
Index: contrib/crossrpms/rtems4.10/avr/rtems-4.10-avr-rtems4.10-gcc.spec
===================================================================
--- contrib/crossrpms/rtems4.10/avr/rtems-4.10-avr-rtems4.10-gcc.spec	(revision 68946ac7481b9e0d5ce43986e29fc18c49181b71)
+++ contrib/crossrpms/rtems4.10/avr/rtems-4.10-avr-rtems4.10-gcc.spec	(revision 241a259dec4d836b991515ef2a67bd7e0bd2cc24)
@@ -61,5 +61,5 @@
 Group:	      	Development/Tools
 Version:        %{gcc_rpmvers}
-Release:      	11%{?dist}
+Release:      	12%{?dist}
 License:      	GPL
 URL:		http://gcc.gnu.org
@@ -101,5 +101,5 @@
 Requires:	rtems-4.10-gcc-common
 Requires:	rtems-4.10-avr-rtems4.10-binutils
-Requires:	rtems-4.10-avr-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+Requires:	rtems-4.10-avr-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 
 
@@ -263,4 +263,8 @@
 %endif
 
+  # Bug in gcc > 4.1.0: Installs an unused, empty directory
+  if test -d ${RPM_BUILD_ROOT}%{_prefix}/avr-rtems4.10/include/bits; then
+    rmdir ${RPM_BUILD_ROOT}%{_prefix}/avr-rtems4.10/include/bits
+  fi
 
   # Collect multilib subdirectories
@@ -423,5 +427,5 @@
 # Version:        %{gcc_rpmvers}
 # Requires:       rtems-4.10-avr-rtems4.10-binutils
-# Requires:       rtems-4.10-avr-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+# Requires:       rtems-4.10-avr-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 # License:	GPL
 
@@ -540,5 +544,5 @@
 License:	Distributable
 Version:	%{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 
 Requires:	rtems-4.10-newlib-common
@@ -560,5 +564,5 @@
 Group:          Development/Tools
 Version:        %{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 License:	Distributable
 
Index: contrib/crossrpms/rtems4.10/bfin/rtems-4.10-bfin-rtems4.10-gcc.spec
===================================================================
--- contrib/crossrpms/rtems4.10/bfin/rtems-4.10-bfin-rtems4.10-gcc.spec	(revision 68946ac7481b9e0d5ce43986e29fc18c49181b71)
+++ contrib/crossrpms/rtems4.10/bfin/rtems-4.10-bfin-rtems4.10-gcc.spec	(revision 241a259dec4d836b991515ef2a67bd7e0bd2cc24)
@@ -61,5 +61,5 @@
 Group:	      	Development/Tools
 Version:        %{gcc_rpmvers}
-Release:      	11%{?dist}
+Release:      	12%{?dist}
 License:      	GPL
 URL:		http://gcc.gnu.org
@@ -101,5 +101,5 @@
 Requires:	rtems-4.10-gcc-common
 Requires:	rtems-4.10-bfin-rtems4.10-binutils
-Requires:	rtems-4.10-bfin-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+Requires:	rtems-4.10-bfin-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 
 
@@ -435,5 +435,5 @@
 # Version:        %{gcc_rpmvers}
 # Requires:       rtems-4.10-bfin-rtems4.10-binutils
-# Requires:       rtems-4.10-bfin-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+# Requires:       rtems-4.10-bfin-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 # License:	GPL
 
@@ -587,5 +587,5 @@
 License:	Distributable
 Version:	%{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 
 Requires:	rtems-4.10-newlib-common
@@ -607,5 +607,5 @@
 Group:          Development/Tools
 Version:        %{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 License:	Distributable
 
Index: contrib/crossrpms/rtems4.10/h8300/rtems-4.10-h8300-rtems4.10-gcc.spec
===================================================================
--- contrib/crossrpms/rtems4.10/h8300/rtems-4.10-h8300-rtems4.10-gcc.spec	(revision 68946ac7481b9e0d5ce43986e29fc18c49181b71)
+++ contrib/crossrpms/rtems4.10/h8300/rtems-4.10-h8300-rtems4.10-gcc.spec	(revision 241a259dec4d836b991515ef2a67bd7e0bd2cc24)
@@ -61,5 +61,5 @@
 Group:	      	Development/Tools
 Version:        %{gcc_rpmvers}
-Release:      	11%{?dist}
+Release:      	12%{?dist}
 License:      	GPL
 URL:		http://gcc.gnu.org
@@ -101,5 +101,5 @@
 Requires:	rtems-4.10-gcc-common
 Requires:	rtems-4.10-h8300-rtems4.10-binutils
-Requires:	rtems-4.10-h8300-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+Requires:	rtems-4.10-h8300-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 
 
@@ -435,5 +435,5 @@
 # Version:        %{gcc_rpmvers}
 # Requires:       rtems-4.10-h8300-rtems4.10-binutils
-# Requires:       rtems-4.10-h8300-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+# Requires:       rtems-4.10-h8300-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 # License:	GPL
 
@@ -587,5 +587,5 @@
 License:	Distributable
 Version:	%{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 
 Requires:	rtems-4.10-newlib-common
@@ -607,5 +607,5 @@
 Group:          Development/Tools
 Version:        %{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 License:	Distributable
 
Index: contrib/crossrpms/rtems4.10/i386/rtems-4.10-i386-rtems4.10-gcc.spec
===================================================================
--- contrib/crossrpms/rtems4.10/i386/rtems-4.10-i386-rtems4.10-gcc.spec	(revision 68946ac7481b9e0d5ce43986e29fc18c49181b71)
+++ contrib/crossrpms/rtems4.10/i386/rtems-4.10-i386-rtems4.10-gcc.spec	(revision 241a259dec4d836b991515ef2a67bd7e0bd2cc24)
@@ -61,5 +61,5 @@
 Group:	      	Development/Tools
 Version:        %{gcc_rpmvers}
-Release:      	11%{?dist}
+Release:      	12%{?dist}
 License:      	GPL
 URL:		http://gcc.gnu.org
@@ -101,5 +101,5 @@
 Requires:	rtems-4.10-gcc-common
 Requires:	rtems-4.10-i386-rtems4.10-binutils
-Requires:	rtems-4.10-i386-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+Requires:	rtems-4.10-i386-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 
 
@@ -435,5 +435,5 @@
 # Version:        %{gcc_rpmvers}
 # Requires:       rtems-4.10-i386-rtems4.10-binutils
-# Requires:       rtems-4.10-i386-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+# Requires:       rtems-4.10-i386-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 # License:	GPL
 
@@ -587,5 +587,5 @@
 License:	Distributable
 Version:	%{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 
 Requires:	rtems-4.10-newlib-common
@@ -607,5 +607,5 @@
 Group:          Development/Tools
 Version:        %{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 License:	Distributable
 
Index: contrib/crossrpms/rtems4.10/lm32/rtems-4.10-lm32-rtems4.10-gcc.spec
===================================================================
--- contrib/crossrpms/rtems4.10/lm32/rtems-4.10-lm32-rtems4.10-gcc.spec	(revision 68946ac7481b9e0d5ce43986e29fc18c49181b71)
+++ contrib/crossrpms/rtems4.10/lm32/rtems-4.10-lm32-rtems4.10-gcc.spec	(revision 241a259dec4d836b991515ef2a67bd7e0bd2cc24)
@@ -61,5 +61,5 @@
 Group:	      	Development/Tools
 Version:        %{gcc_rpmvers}
-Release:      	11%{?dist}
+Release:      	12%{?dist}
 License:      	GPL
 URL:		http://gcc.gnu.org
@@ -101,5 +101,5 @@
 Requires:	rtems-4.10-gcc-common
 Requires:	rtems-4.10-lm32-rtems4.10-binutils
-Requires:	rtems-4.10-lm32-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+Requires:	rtems-4.10-lm32-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 
 
@@ -435,5 +435,5 @@
 # Version:        %{gcc_rpmvers}
 # Requires:       rtems-4.10-lm32-rtems4.10-binutils
-# Requires:       rtems-4.10-lm32-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+# Requires:       rtems-4.10-lm32-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 # License:	GPL
 
@@ -587,5 +587,5 @@
 License:	Distributable
 Version:	%{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 
 Requires:	rtems-4.10-newlib-common
@@ -607,5 +607,5 @@
 Group:          Development/Tools
 Version:        %{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 License:	Distributable
 
Index: contrib/crossrpms/rtems4.10/m32c/rtems-4.10-m32c-rtems4.10-gcc.spec
===================================================================
--- contrib/crossrpms/rtems4.10/m32c/rtems-4.10-m32c-rtems4.10-gcc.spec	(revision 68946ac7481b9e0d5ce43986e29fc18c49181b71)
+++ contrib/crossrpms/rtems4.10/m32c/rtems-4.10-m32c-rtems4.10-gcc.spec	(revision 241a259dec4d836b991515ef2a67bd7e0bd2cc24)
@@ -61,5 +61,5 @@
 Group:	      	Development/Tools
 Version:        %{gcc_rpmvers}
-Release:      	11%{?dist}
+Release:      	12%{?dist}
 License:      	GPL
 URL:		http://gcc.gnu.org
@@ -100,5 +100,5 @@
 
 Requires:	rtems-4.10-m32c-rtems4.10-binutils
-Requires:	rtems-4.10-m32c-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+Requires:	rtems-4.10-m32c-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 
 
@@ -263,4 +263,8 @@
 %endif
 
+  # Bug in gcc > 4.1.0: Installs an unused, empty directory
+  if test -d ${RPM_BUILD_ROOT}%{_prefix}/m32c-rtems4.10/include/bits; then
+    rmdir ${RPM_BUILD_ROOT}%{_prefix}/m32c-rtems4.10/include/bits
+  fi
 
   # Collect multilib subdirectories
@@ -423,5 +427,5 @@
 # Version:        %{gcc_rpmvers}
 # Requires:       rtems-4.10-m32c-rtems4.10-binutils
-# Requires:       rtems-4.10-m32c-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+# Requires:       rtems-4.10-m32c-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 # License:	GPL
 
@@ -482,5 +486,5 @@
 License:	Distributable
 Version:	%{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 
 
Index: contrib/crossrpms/rtems4.10/m32r/rtems-4.10-m32r-rtems4.10-gcc.spec
===================================================================
--- contrib/crossrpms/rtems4.10/m32r/rtems-4.10-m32r-rtems4.10-gcc.spec	(revision 68946ac7481b9e0d5ce43986e29fc18c49181b71)
+++ contrib/crossrpms/rtems4.10/m32r/rtems-4.10-m32r-rtems4.10-gcc.spec	(revision 241a259dec4d836b991515ef2a67bd7e0bd2cc24)
@@ -61,5 +61,5 @@
 Group:	      	Development/Tools
 Version:        %{gcc_rpmvers}
-Release:      	11%{?dist}
+Release:      	12%{?dist}
 License:      	GPL
 URL:		http://gcc.gnu.org
@@ -100,5 +100,5 @@
 
 Requires:	rtems-4.10-m32r-rtems4.10-binutils
-Requires:	rtems-4.10-m32r-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+Requires:	rtems-4.10-m32r-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 
 
@@ -263,4 +263,8 @@
 %endif
 
+  # Bug in gcc > 4.1.0: Installs an unused, empty directory
+  if test -d ${RPM_BUILD_ROOT}%{_prefix}/m32r-rtems4.10/include/bits; then
+    rmdir ${RPM_BUILD_ROOT}%{_prefix}/m32r-rtems4.10/include/bits
+  fi
 
   # Collect multilib subdirectories
@@ -423,5 +427,5 @@
 # Version:        %{gcc_rpmvers}
 # Requires:       rtems-4.10-m32r-rtems4.10-binutils
-# Requires:       rtems-4.10-m32r-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+# Requires:       rtems-4.10-m32r-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 # License:	GPL
 
@@ -482,5 +486,5 @@
 License:	Distributable
 Version:	%{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 
 
Index: contrib/crossrpms/rtems4.10/m68k/rtems-4.10-m68k-rtems4.10-gcc.spec
===================================================================
--- contrib/crossrpms/rtems4.10/m68k/rtems-4.10-m68k-rtems4.10-gcc.spec	(revision 68946ac7481b9e0d5ce43986e29fc18c49181b71)
+++ contrib/crossrpms/rtems4.10/m68k/rtems-4.10-m68k-rtems4.10-gcc.spec	(revision 241a259dec4d836b991515ef2a67bd7e0bd2cc24)
@@ -61,5 +61,5 @@
 Group:	      	Development/Tools
 Version:        %{gcc_rpmvers}
-Release:      	11%{?dist}
+Release:      	12%{?dist}
 License:      	GPL
 URL:		http://gcc.gnu.org
@@ -101,5 +101,5 @@
 Requires:	rtems-4.10-gcc-common
 Requires:	rtems-4.10-m68k-rtems4.10-binutils
-Requires:	rtems-4.10-m68k-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+Requires:	rtems-4.10-m68k-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 
 
@@ -435,5 +435,5 @@
 # Version:        %{gcc_rpmvers}
 # Requires:       rtems-4.10-m68k-rtems4.10-binutils
-# Requires:       rtems-4.10-m68k-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+# Requires:       rtems-4.10-m68k-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 # License:	GPL
 
@@ -587,5 +587,5 @@
 License:	Distributable
 Version:	%{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 
 Requires:	rtems-4.10-newlib-common
@@ -607,5 +607,5 @@
 Group:          Development/Tools
 Version:        %{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 License:	Distributable
 
Index: contrib/crossrpms/rtems4.10/mips/rtems-4.10-mips-rtems4.10-gcc.spec
===================================================================
--- contrib/crossrpms/rtems4.10/mips/rtems-4.10-mips-rtems4.10-gcc.spec	(revision 68946ac7481b9e0d5ce43986e29fc18c49181b71)
+++ contrib/crossrpms/rtems4.10/mips/rtems-4.10-mips-rtems4.10-gcc.spec	(revision 241a259dec4d836b991515ef2a67bd7e0bd2cc24)
@@ -61,5 +61,5 @@
 Group:	      	Development/Tools
 Version:        %{gcc_rpmvers}
-Release:      	11%{?dist}
+Release:      	12%{?dist}
 License:      	GPL
 URL:		http://gcc.gnu.org
@@ -101,5 +101,5 @@
 Requires:	rtems-4.10-gcc-common
 Requires:	rtems-4.10-mips-rtems4.10-binutils
-Requires:	rtems-4.10-mips-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+Requires:	rtems-4.10-mips-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 
 
@@ -435,5 +435,5 @@
 # Version:        %{gcc_rpmvers}
 # Requires:       rtems-4.10-mips-rtems4.10-binutils
-# Requires:       rtems-4.10-mips-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+# Requires:       rtems-4.10-mips-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 # License:	GPL
 
@@ -587,5 +587,5 @@
 License:	Distributable
 Version:	%{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 
 Requires:	rtems-4.10-newlib-common
@@ -607,5 +607,5 @@
 Group:          Development/Tools
 Version:        %{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 License:	Distributable
 
Index: contrib/crossrpms/rtems4.10/powerpc/rtems-4.10-powerpc-rtems4.10-gcc.spec
===================================================================
--- contrib/crossrpms/rtems4.10/powerpc/rtems-4.10-powerpc-rtems4.10-gcc.spec	(revision 68946ac7481b9e0d5ce43986e29fc18c49181b71)
+++ contrib/crossrpms/rtems4.10/powerpc/rtems-4.10-powerpc-rtems4.10-gcc.spec	(revision 241a259dec4d836b991515ef2a67bd7e0bd2cc24)
@@ -61,5 +61,5 @@
 Group:	      	Development/Tools
 Version:        %{gcc_rpmvers}
-Release:      	11%{?dist}
+Release:      	12%{?dist}
 License:      	GPL
 URL:		http://gcc.gnu.org
@@ -101,5 +101,5 @@
 Requires:	rtems-4.10-gcc-common
 Requires:	rtems-4.10-powerpc-rtems4.10-binutils
-Requires:	rtems-4.10-powerpc-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+Requires:	rtems-4.10-powerpc-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 
 
@@ -435,5 +435,5 @@
 # Version:        %{gcc_rpmvers}
 # Requires:       rtems-4.10-powerpc-rtems4.10-binutils
-# Requires:       rtems-4.10-powerpc-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+# Requires:       rtems-4.10-powerpc-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 # License:	GPL
 
@@ -587,5 +587,5 @@
 License:	Distributable
 Version:	%{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 
 Requires:	rtems-4.10-newlib-common
@@ -607,5 +607,5 @@
 Group:          Development/Tools
 Version:        %{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 License:	Distributable
 
Index: contrib/crossrpms/rtems4.10/sh/rtems-4.10-sh-rtems4.10-gcc.spec
===================================================================
--- contrib/crossrpms/rtems4.10/sh/rtems-4.10-sh-rtems4.10-gcc.spec	(revision 68946ac7481b9e0d5ce43986e29fc18c49181b71)
+++ contrib/crossrpms/rtems4.10/sh/rtems-4.10-sh-rtems4.10-gcc.spec	(revision 241a259dec4d836b991515ef2a67bd7e0bd2cc24)
@@ -61,5 +61,5 @@
 Group:	      	Development/Tools
 Version:        %{gcc_rpmvers}
-Release:      	11%{?dist}
+Release:      	12%{?dist}
 License:      	GPL
 URL:		http://gcc.gnu.org
@@ -101,5 +101,5 @@
 Requires:	rtems-4.10-gcc-common
 Requires:	rtems-4.10-sh-rtems4.10-binutils
-Requires:	rtems-4.10-sh-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+Requires:	rtems-4.10-sh-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 
 
@@ -435,5 +435,5 @@
 # Version:        %{gcc_rpmvers}
 # Requires:       rtems-4.10-sh-rtems4.10-binutils
-# Requires:       rtems-4.10-sh-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+# Requires:       rtems-4.10-sh-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 # License:	GPL
 
@@ -587,5 +587,5 @@
 License:	Distributable
 Version:	%{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 
 Requires:	rtems-4.10-newlib-common
@@ -607,5 +607,5 @@
 Group:          Development/Tools
 Version:        %{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 License:	Distributable
 
Index: contrib/crossrpms/rtems4.10/sparc/rtems-4.10-sparc-rtems4.10-gcc.spec
===================================================================
--- contrib/crossrpms/rtems4.10/sparc/rtems-4.10-sparc-rtems4.10-gcc.spec	(revision 68946ac7481b9e0d5ce43986e29fc18c49181b71)
+++ contrib/crossrpms/rtems4.10/sparc/rtems-4.10-sparc-rtems4.10-gcc.spec	(revision 241a259dec4d836b991515ef2a67bd7e0bd2cc24)
@@ -61,5 +61,5 @@
 Group:	      	Development/Tools
 Version:        %{gcc_rpmvers}
-Release:      	11%{?dist}
+Release:      	12%{?dist}
 License:      	GPL
 URL:		http://gcc.gnu.org
@@ -101,5 +101,5 @@
 Requires:	rtems-4.10-gcc-common
 Requires:	rtems-4.10-sparc-rtems4.10-binutils
-Requires:	rtems-4.10-sparc-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+Requires:	rtems-4.10-sparc-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 
 
@@ -435,5 +435,5 @@
 # Version:        %{gcc_rpmvers}
 # Requires:       rtems-4.10-sparc-rtems4.10-binutils
-# Requires:       rtems-4.10-sparc-rtems4.10-newlib = %{newlib_version}-32%{?dist}
+# Requires:       rtems-4.10-sparc-rtems4.10-newlib = %{newlib_version}-33%{?dist}
 # License:	GPL
 
@@ -587,5 +587,5 @@
 License:	Distributable
 Version:	%{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 
 Requires:	rtems-4.10-newlib-common
@@ -607,5 +607,5 @@
 Group:          Development/Tools
 Version:        %{newlib_version}
-Release:        32%{?dist}
+Release:        33%{?dist}
 License:	Distributable
 